#include <pic.h>


__CONFIG (HS & UNPROTECT & LVPDIS 
& BORDIS & MCLRDIS & PWRTEN & WDTDIS);

__EEPROM_DATA(0x08,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF);

#define key_min RB0
#define key_set RB1
#define key_max RB2

void bcd_char (unsigned char x); //    -  
unsigned char x3, x2, x1;
void BCDTime (unsigned char ho, unsigned char mi); //   
void BCDTermo (void); //   

extern void OutTime (void);  //     
extern void OutTermo (void); //      
extern void OutTimeFast (void); //     ( )

extern unsigned char ArrTime[4]; //     
extern unsigned char seconds, minutes, hours; //   
unsigned char old_seconds, old_minutes; //  
// old_seconds -    
// old_minutes -   
unsigned char minutes_a, hours_a; // alarm   ()
unsigned char fAlarm=1; //   

extern void time_sta (void); //  ,   
extern void time_read (void); //  , , ...
extern void time_write (void); //  ,     ...

unsigned char Rezim; //  0-, 1-, 2-
void TimeMin (void);//   
void TimeMax (void);//   
unsigned int TimeOut;

extern unsigned char ArrRow [30]; //   

extern unsigned char ArrTermo[3]; //   
extern void DS18 (void); //     
extern unsigned char term; //   
extern unsigned char pol; //  "" 
// 0 - , 1 - 



//-------------------------------------------------------------
//   
//-------------------------------------------------------------
void main (void)
{ //   
static unsigned int TimeBlink;

INTCON = 0;  //   
TRISA = 0b00100000; TRISB = 0b00110111; //  
CMCON = 0x07; //   (    )
PORTA = 0; PORTB = 0; //    
RBPU = 0; //  R (1-, 0-)
//   1
PEIE   = 1;  //   
T1CKPS0 = 0; // T1CON 
T1CKPS1 = 0; //   
T1OSCEN = 0; //   
TMR1CS  = 0; //   
//TMR1H = TMR1H_; TMR1L = TMR1L_;
TMR1ON  = 1; //   tmr1
CCP1CON = 0; //   
TMR1IE  = 1; //     tmr1
//   2  
T2CON   = 0b00000111; //  1:16,  TMR2,  1:16
    //CCP1CON = 0b00001100; //  
TMR2IE = 1; // 1-, 0-  ()
   
//  
GIE    = 1;	 //  

DS18 (); //     
//  ,    

//       
time_sta (); //  ,   
time_read (); //  , , ...
	BCDTime (hours, minutes); //   
	OutTime ();  //     
// "OutTime();"      
Rezim = 1; //  0-, 1-, 2-

//    
hours_a   = EEPROM_READ(0);
minutes_a = EEPROM_READ(1);

while (1)
{ //   

time_read (); //  , , ...

// ............................................................
//     
// ............................................................
//     
if (seconds == 25 && Rezim == 1) 
	{
	Rezim = 0;
	BCDTermo();
	OutTermo();
	}
//     
if (seconds == 35 && Rezim == 0)
	{
	Rezim = 1;
	// BCDTime(hours, minutes);    
	OutTime();//   
	}
//      
if (old_minutes != minutes && Rezim == 1)
	{
	BCDTime(hours, minutes); 
	OutTime();//   
	}
	old_minutes = minutes; //     
// ............................................................



//    ()
if (old_seconds != seconds && Rezim == 1)
{
ArrRow[12] = 0b00100100;
TimeBlink++;
if (TimeBlink > 0x2ff)
	{
	TimeBlink = 0;
	ArrRow[12] = 0b00000000;
	old_seconds = seconds;
	}
}

// ............................................................
//   
// ............................................................
if (hours == hours_a && minutes == minutes_a && fAlarm==1)
{
if (hours_a==0 && minutes_a==0) //   
CCP1CON = 0; else CCP1CON = 0b00001100;
fAlarm = 0;
} 
//  fAlarm=0    
// ..  (CCP1CON)       

if (minutes != minutes_a) 
{CCP1CON = 0; fAlarm = 1;}
//   ()    
//     

//   
if (hours_a==0 && minutes_a==0) 
{CCP1CON = 0; fAlarm = 0;}


// ............................................................
//   
// ............................................................
if (!key_max) TimeMax(); //   
if (!key_min) TimeMin(); //   
if (!key_set) 
{
TimeBlink = 0xff; while (TimeBlink-->0); //  
while (!key_set); //     
TimeBlink = 0xff; while (TimeBlink-->0); //  
if (CCP1CON != 0) {CCP1CON = 0; goto m1;} //   ()  
if (Rezim == 2)  //   /
	{
	Rezim = 1; // 
	BCDTime(hours, minutes); 
	OutTime();//   
	}
	else 
	{
	Rezim = 2; // 
	BCDTime (hours_a, minutes_a); //   
	OutTimeFast (); //     ( )
	ArrRow[12] = 0b01000000;
	TimeOut = 0xffff;
	}
m1: ;
}


// ............................................................
//      
// ............................................................
if (Rezim==2 && TimeOut>0) TimeOut--;
if (TimeOut==1)
{
	TimeOut=0; // 
	Rezim = 1; //    
	BCDTime(hours, minutes); //   
	OutTime();//   
}


} //   
} //   


//-------------------------------------------------------------
//    -  
//-------------------------------------------------------------
void bcd_char (unsigned char x){
x3=x2=x1=0;
while (x >= 100){x3++; x = x-100;}
while (x >= 10) {x2++; x = x-10; }
                 x1 =  x+x1;
}

//-------------------------------------------------------------
//   
//-------------------------------------------------------------
void BCDTime (unsigned char ho, unsigned char mi)
{
bcd_char(ho);   
	ArrTime[0]=x2; 
	ArrTime[1]=x1;
bcd_char(mi);
	ArrTime[2]=x2;
	ArrTime[3]=x1; 
}

//-------------------------------------------------------------
//   
//-------------------------------------------------------------
void BCDTermo (void)
{
DS18 (); //     
ArrTermo[0] = pol;
bcd_char(term);
ArrTermo[1]=x2; 
ArrTermo[2]=x1;
}


//-------------------------------------------------------------
//   (/)
//-------------------------------------------------------------
void TimeMin (void)
{
static unsigned int CountKey;
CountKey++;
if (CountKey == 0xff)
{
CountKey = 0;
if (Rezim == 1)
	{
	minutes--;
	if (minutes > 59) {minutes=59;hours--;}
	if (hours   > 23)  hours=23;
	time_write (); //  ,     ...
	old_minutes = minutes; //   
	BCDTime (hours, minutes); //   
	OutTimeFast (); //     ( )
	}

if (Rezim == 2)
	{
	minutes_a--;
	if (minutes_a > 59) {minutes_a=59;hours_a--;}
	if (hours_a   > 23)  hours_a=23;
	BCDTime (hours_a, minutes_a); //   
	OutTimeFast (); //     ( )
	ArrRow[12] = 0b01000000;
	EEPROM_WRITE(0,hours_a);
	EEPROM_WRITE(1,minutes_a);
	TimeOut = 0xffff;
	}
} //  if (CountKey == 0x2ff)
}

void TimeMax (void)
{
static unsigned int CountKey;
CountKey++;
if (CountKey == 0xff)
{
CountKey = 0;
if (Rezim == 1)
	{
	minutes++;
	if (minutes > 59) {minutes=0;hours++;}
	if (hours   > 23)  hours=0;
	time_write (); //  ,     ...
	old_minutes = minutes; //   
	BCDTime (hours, minutes); //   
	OutTimeFast (); //     ( )
	}

if (Rezim == 2)
	{
	minutes_a++;
	if (minutes_a > 59) {minutes_a=0;hours_a++;}
	if (hours_a   > 23)  hours_a=0;
	BCDTime (hours_a, minutes_a); //   
	OutTimeFast (); //     ( )
	ArrRow[12] = 0b01000000;
	EEPROM_WRITE(0,hours_a);
	EEPROM_WRITE(1,minutes_a);
	TimeOut = 0xffff;
	}
} //  if (CountKey == 0x2ff)
}
